import java.util.concurrent.locks.*;

class FullEmpty<VarData> {
  boolean full = false;
  VarData content = null;
  final Lock lock = new ReentrantLock();
  final Condition nowFull = lock.newCondition();
  final Condition nowEmpty = lock.newCondition();

  public FullEmpty() { }

  public void put(VarData v) {
    lock.lock();
    try {
      while (full)
        nowEmpty.await();
      content = v;
      full = true;
      nowFull.signal();
    } catch (InterruptedException e) {
      System.exit(1);
    } finally {
      lock.unlock();
    }
  }

  public VarData get() {
    lock.lock();
    try {
      while (!full)
        nowFull.await();
      nowEmpty.signal();
      full = false;
      return content;
    } catch (InterruptedException e) {
      System.exit(1);
      return null;
    } finally {
      lock.unlock();
    }
  }
}
