#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>

#include "config.h"
#include "reduce_client.h"
#include "reduce_server.h"
#include "fullempty.h"

static int t, t_plus, single_len, last_t, last_len;

static struct fullempty_t *result_var;
static struct fullempty_t **nodeval_var;

static void *start_server(void *);

int main(int argc, char **argv)
{
  pthread_t *c;
  int i;
  result_t result;

  if (argc != 2) {
    printf("expected a single argument\n");
    abort();
  }

  t = atoi(argv[1]);

  if (t <= 0) {
    printf("bad thread count: %s\n", argv[1]);
    abort();
  }

  for (t_plus = 1; t_plus < t; t_plus *= 2) { }

  setup();

  single_len = n / t;

  /* Last server waiting_gets leftovers if the array doesn't divide evenly: */
  last_t = t - 1;
  last_len = n - ((t - 1) * single_len);

  result_var = fullempty_create(sizeof(result_t));
  nodeval_var = (struct fullempty_t **)malloc(t * sizeof(struct fullempty_t *));
  for (i = 0; i < t;i++) {
    nodeval_var[i] = fullempty_create(sizeof(tally_t));
  }

  c = (pthread_t *)malloc(t * sizeof(pthread_t));

  for (i = 0; i < t; i++) {
    pthread_create(&c[i], NULL, start_server, (void *)i);
  }
  
  fullempty_get(result_var, sizeof(result_t), &result);
  
  for (i = 0; i < t; i++) {
    pthread_join(c[i], NULL);
  }

  print_result(result);

  return 0;
}

static tally_t localTally(int size, data_t *myArray);

static void *start_server(void *id)
{
  int index = (int)id;
  int n = ((index == last_t) ? last_len : single_len);
  data_t *myArray;

  myArray = array + (index * single_len);

  {
    tally_t tally, child_tally;
    int stride;
    
    tally = localTally(n, myArray);
    
    for (stride = 1; stride < t_plus; stride *= 2) {
      if (index % (2 * stride) == 0) {
        if (index + stride < t) {
          fullempty_get(nodeval_var[index + stride], sizeof(tally_t), &child_tally);
          tally = combine(tally, child_tally);
        }
      } else {
        fullempty_put(nodeval_var[index], sizeof(tally_t), &tally);
        break;
      }
    }
    
    if (index == 0)  {
      result_t result;
      result = reduceGen(tally);
      fullempty_put(result_var, sizeof(result), &result);
    }
  }
  
  return NULL;
}

tally_t localTally(int size, data_t *myArray)
{
  int i;
  tally_t tally = init();
 
  for (i = 0; i < size; i++)
   tally = accum(tally, i, myArray);

  return tally;
}

/* ********************************************************************** */

